#include <defBF533.h>

.extern _UNCOMPR_ADDR;
.extern _UNCOMPR_LEN;

.extern stackp;

.section program;

.global _SetupSDRAM;
.type _SetupSDRAM,STT_OBJECT;

.global _RestoreSP;
.type _RestoreSP,STT_OBJECT;

.align 4;

_SetupSDRAM:

	P0.L = EBIU_SDRRC & 0xFFFF;
	P0.H = (EBIU_SDRRC >> 16) & 0xFFFF;		//SDRAM Refresh Rate Control Register
	R0 = 0x0817(Z);					
	W[P0] = R0;							
	SSYNC;	

	P0.L = EBIU_SDBCTL & 0xFFFF;			
	P0.H = (EBIU_SDBCTL >> 16) & 0xFFFF;	//SDRAM Memory Bank Control Register
	R0 = 0x0013(Z);
	[P0] = R0;
	SSYNC;		

	P0.L = EBIU_SDGCTL & 0xFFFF;			
	P0.H = (EBIU_SDGCTL >> 16) & 0xFFFF;	//SDRAM Memory Global Control Register
	R0.L = 0x998D;
	R0.H = 0x0091;
	[P0] = R0;
	SSYNC;	

	P0.H = stackp;
	P0.L = stackp;
	SP = [P0];
	
	RTS;
	
._SetupSDRAM.end:

_RestoreSP:
	P0.H = _UNCOMPR_ADDR;
	P0.L = _UNCOMPR_ADDR;
	R0 = [P0];

	P0.H = _UNCOMPR_LEN;
	P0.L = _UNCOMPR_LEN;
	R1 = [P0];	
	
	R0 = R0 + R1;
	R2 = R0 + R1;
	R0 += -1;
	P0 = R0;		//READ PTR
	R2 += -2;
	P1 = R2;

	LC0 = R1;
	LSETUP(PAD_BEGIN, PAD_END) LC0;
PAD_BEGIN:	R0 = B[P0--](Z);
PAD_END:	W[P1--] = R0;

	P0.H = _UNCOMPR_ADDR;
	P0.L = _UNCOMPR_ADDR;
	R0 = [P0];

	L3 = [SP++];
	L2 = [SP++];	
	L1 = [SP++];
	L0 = [SP++];
	M3 = [SP++];
	M2 = [SP++];
	M1 = [SP++];
	M0 = [SP++];
	B3 = [SP++];
	B2 = [SP++];
	B1 = [SP++];
	B0 = [SP++];
	I3 = [SP++];
	I2 = [SP++];
	I1 = [SP++];
	I0 = [SP++];
	(p5:0) = [SP++];  		//Restore Regs from Stack
	(r7:1) = [SP++];
	RETS = [SP++];
	RETS = [SP++];
	ASTAT = [SP++];
	
	RTS;
	
._RestoreSP.end:

