#!/usr/bin/perl

$sourcedir = $ARGV[0];
$destdir = $ARGV[1];
if ((!$destdir) && ($destdir eq "")) {
	$destdir = $sourcedir."_intel.ldr";
}

	open(FILE, "<".$sourcedir);
	@LINES = <FILE>;
	close FILE;
	
	open(FILE, ">".$destdir);
		
	$address = 0;
	$baseAddr = 0;
	$baseChecksum = 0;
	$hexline = "";	
	$lineCount = 0;
	
	print FILE ":020000040000FA\n";
	
	foreach $line (@LINES) {
		$line =~ s/\s//g;	# delete blanks etc.
		$line =~ s/\/\/.+$//g;  #delete comments
		$hexline.= $line;
		$lineCount++;
		
		if (($line eq "") || (length($hexline) >= 48) || ($lineCount eq 0x10000)) {
			if ($hexline ne "") {
				&intelrecord($address, $hexline);
				$address += (length($hexline)/2);
				$hexline = "";				
			}
			if ($lineCount eq 0x10000) {
				$lineCount = 0;
				$address = 0;
			}
		}		
	}
	
	if ($hexline ne "") {
		&intelrecord($address, $hexline);
	}
	
	print FILE ":00000001FF\n";
	
	close FILE;
	
exit(0);	
	
	
sub intelrecord
{
	my $size = length($hexline)/2;
	my $checksum = $size;	
	$checksum+= ($address & 0xff);	
	$checksum+= ($address >> 8);		
	my $i=0;
	
	while ($i < length($hexline))
	{		
		$checksum += &gethex(substr($hexline,$i,2));	
		$i+= 2;
	}
	$checksum = 0xff&$checksum;	
	$checksum = (256-$checksum);
	
	if ($lineCount eq 0x10000) {
		$baseAddr++;
		$baseChecksum = (250-(0xff&$baseAddr));		
	
		printf FILE ":%02X%04X00%s%02X\n", $size, $address, $hexline, $checksum;
		printf FILE ":02000004%04X%02X\n", $baseAddr, $baseChecksum;
	}
	else {
		printf FILE ":%02X%04X00%s%02X\n", $size, $address, $hexline, $checksum;
	}
}	
	
sub gethex
{	
	my $i = length($_[0]);
	my $str = uc($_[0]);
	$str =~ s/[^A-Z0-9]/0/g;
	
	my $val = 0;
	my $tmp;
	my $factor = 1;
	while ($i > 0) {
		$i--;		
		my $c = substr($str,$i,1);
		if ($c =~ /[0-9]/) {
			$tmp = ord($c)-ord('0');
			$val += $tmp * $factor;			
		} else {
			$tmp = ord($c)-ord('A')+10; 
			$val += $tmp * $factor;
		}		
		$factor *= 16;	
	}		
	return $val;
}